(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["@babel/runtime/regenerator", "@babel/runtime/helpers/asyncToGenerator"], factory);
  } else if (typeof exports !== "undefined") {
    factory(require("@babel/runtime/regenerator"), require("@babel/runtime/helpers/asyncToGenerator"));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.regenerator, global.asyncToGenerator);
    global.didResolver = mod.exports;
  }
})(this, function (_regenerator, _asyncToGenerator2) {
  "use strict";

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  _regenerator = _interopRequireDefault(_regenerator);
  _asyncToGenerator2 = _interopRequireDefault(_asyncToGenerator2);

  var _require = require('interlinked-server-apis/dist/api'),
      resolveQuorumSpherityAPI = _require.resolveQuorumSpherityAPI,
      resolveUniResolverDIFAPI = _require.resolveUniResolverDIFAPI,
      resolveUniResolverOSiPAPI = _require.resolveUniResolverOSiPAPI,
      resolveUniResolverSpherityProxyAPI = _require.resolveUniResolverSpherityProxyAPI;

  var resolveQuorumSpherity =
  /*#__PURE__*/
  function () {
    var _ref = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(did) {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return resolveQuorumSpherityAPI({
                did: did
              });

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function resolveQuorumSpherity(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var resolveUniResolverDIF =
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(did) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return resolveUniResolverDIFAPI(did);

            case 2:
              return _context2.abrupt("return", _context2.sent);

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function resolveUniResolverDIF(_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  var resolveUniResolverOSiP =
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(did) {
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return resolveUniResolverOSiPAPI(did);

            case 2:
              return _context3.abrupt("return", _context3.sent);

            case 3:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function resolveUniResolverOSiP(_x3) {
      return _ref3.apply(this, arguments);
    };
  }(); // const resolveUniResolverSpherity = async did => await resolveUniResolverSpherityAPI(did)


  var resolveUniResolverSpherityProxy =
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(did) {
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return resolveUniResolverSpherityProxyAPI({
                did: did
              });

            case 2:
              return _context4.abrupt("return", _context4.sent);

            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function resolveUniResolverSpherityProxy(_x4) {
      return _ref4.apply(this, arguments);
    };
  }();

  var resolvers = {
    InterlinkedQuorum: resolveQuorumSpherity,
    UniResolverDIF: resolveUniResolverDIF,
    UniResolverOSiP: resolveUniResolverOSiP,
    UniResolverSpherity: resolveUniResolverSpherityProxy
  };

  function didResolver(resolver) {
    var impl = resolvers[resolver];
    if (!impl) throw new Error("Unsupported resolver ".concat(resolver));
    return impl;
  }

  module.exports = didResolver;
});