(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define([], factory);
  } else if (typeof exports !== "undefined") {
    factory();
  } else {
    var mod = {
      exports: {}
    };
    factory();
    global.index = mod.exports;
  }
})(this, function () {
  "use strict";

  var didParser = require('./didParser');

  var didResolver = require('./didResolver');

  var _require = require('./resolve'),
      filterPublicKey = _require.filterPublicKey,
      filterDelegates = _require.filterDelegates,
      filterOwnerAddress = _require.filterOwnerAddress,
      filterService = _require.filterService,
      filterAgentServiceUrl = _require.filterAgentServiceUrl,
      resolve = _require.resolve;

  module.exports = {
    didParser: didParser,
    didResolver: didResolver,
    filterPublicKey: filterPublicKey,
    filterDelegates: filterDelegates,
    filterOwnerAddress: filterOwnerAddress,
    filterService: filterService,
    filterAgentServiceUrl: filterAgentServiceUrl,
    resolve: resolve
  };
});