const didParser = did => {
  if (!did) throw new Error(`DID is not provided: ${did}`)

  const parts = did.match(/^(did)\:([a-zA-Z0-9]+)\:([a-zA-Z0-9]+)$/)
  if (!parts || parts.length !== 4) throw new Error(`DID is not recognized: ${JSON.stringify(parts)}`)

  const parsed = {
    method: parts[2],
    id: parts[3]
  }
  switch (parsed.method) {
    case 'eth':
    case 'ethr':
    case 'uport':
    case 'muport':
    case '7hirten':
    case 'spherity':
      return parsed
    default: 
      throw new Error(`Unsupported DID method: ${parsed.method}`)
  } 
}

module.exports = didParser
