const {
  resolveQuorumSpherityAPI,
  resolveUniResolverDIFAPI,
  resolveUniResolverOSiPAPI,
  // resolveUniResolverSpherityAPI Enable when https
  resolveUniResolverSpherityProxyAPI
} = require('interlinked-server-apis/dist/api')

const resolveQuorumSpherity = async did => await resolveQuorumSpherityAPI({ did })
const resolveUniResolverDIF = async did => await resolveUniResolverDIFAPI(did)
const resolveUniResolverOSiP = async did => await resolveUniResolverOSiPAPI(did)
// const resolveUniResolverSpherity = async did => await resolveUniResolverSpherityAPI(did)
const resolveUniResolverSpherityProxy = async did => await resolveUniResolverSpherityProxyAPI({ did })

const resolvers = {
  InterlinkedQuorum: resolveQuorumSpherity,
  UniResolverDIF: resolveUniResolverDIF,
  UniResolverOSiP: resolveUniResolverOSiP,
  UniResolverSpherity: resolveUniResolverSpherityProxy
}

function didResolver(resolver) {
  const impl = resolvers[resolver]
  if (!impl) throw new Error(`Unsupported resolver ${resolver}`)
  return impl
}

module.exports = didResolver
